CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    Subroutine for the calculation of acoustic phonons
C    scattering rate
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine acoustic_rate(i_count,iv,n_lev,out_file)

       common
     &/pi/pi,two_pi 
     &/temp/tem,Vt
     &/fund_const/q,h,kb,am0,eps_0 
     &/dri/qh
     &/ek/am(3),smh(3),hhm(3)
     &/nonp/af(3),af2(3),af4(3)
     &/scatt_par/emax,de,w(10,3),tau_max(3),max_scatt_mech(3)
     &/scatt_par2/flag_mech(10,3),i_valley(10,3)
     &/table/scatt_table(4000,10,3)
     &/density/density,sound_velocity
     &/acoustic/sigma
     
      integer i_count,iv,n_lev
      real kb
      character*30 out_file

C    Calculate constant

      c_l = density*sound_velocity*sound_velocity
      const = sqrt(2.)*kb*tem/pi/h/c_l
     1      * (am(iv)/h)*(sqrt(am(iv))/h*sqrt(q))*(qh*q)
     2      * sigma*sigma

C    Create scattering table
              
      i_count = i_count + 1
      open(unit = 10, file=out_file, status='unknown')
      write(10,*)'energy  ',out_file
      do i = 1, n_lev
         ee = de*float(i)
         fe = ee*(1.+af(iv)*ee)
         acoustic = const*sqrt(fe)*(1.+af2(iv)*ee)
         scatt_table(i,i_count,iv) = acoustic
         write(10,*)ee,acoustic
      enddo
      close(10)
      
      flag_mech(i_count,iv) = 1
      w(i_count,iv) = 0.
      i_valley(i_count,iv) = iv
            
      return
      end
      