CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     PERFORM THE K-SPACE AND REAL-SPACE MOTION OF THE CARRIERS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       subroutine drift(tau)
       
       common
     &/pi/pi,two_pi 
     &/dri/qh
     &/temp/tem,Vt
     &/ek/am(3),smh(3),hhm(3)
     &/scatt_par/emax,de,w(10,3),tau_max(3),max_scatt_mech(3)
     &/nonp/af(3),af2(3),af4(3)
     &/force/fx,fy,fz
     &/particle_atr/kx,ky,kz,iv,e
          
       real kx,ky,kz,e,tau,k,kxy
       real qh1,dkx,dky,dkz
       real fx,fy,fz
       integer iv
                          
       qh1 = qh*tau
       dkx = -qh1*fx
       dky = -qh1*fy
       dkz = -qh1*fz

       kx = kx+dkx
       ky = ky+dky
       kz = kz+dkz

       skx = kx*kx
       sky = ky*ky
       skz = kz*kz
       sk = skx+sky+skz
       gk = hhm(iv)*sk
       e = 2*gk/(1.+sqrt(1.+af4(iv)*gk))
       
       if(e.le.0.or.e.ge.emax)then
       
          if(e.le.0)then
             e=0
          endif
          if(e.ge.emax)then
            e=emax
          endif
          kxy = sqrt(kx*kx+ky*ky)
          k = sqrt(kxy*kxy+kz*kz)
          if(k.ne.0)then
            cth0 = kz/k
            sth0 = kxy/k
          else
            cth0 = 1
            sth0 = 0.
          endif
          if(kxy.ne.0)then
            cfi0 = kx/kxy
            sfi0 = ky/kxy
          else
            cfi0 = 1.
            sfi0 = 0.
          endif
          k = smh(iv)*sqrt(e*(1.+af(iv)*e))
          kx = k*sth0*cfi0
          ky = k*sth0*sfi0
          kz = k*cth0
       
       endif      

       return
       end
               		
