CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C       PERFORM THE FREE-FLIGHT AND SCATTER 
C       PART WITHIN ONE TIME INTERVAL    
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       subroutine free_flight_scatter(n_lev,nsim)
        
       common
     &/ran_var/iso
     &/scatt_par/emax,de,w(10,3),tau_max(3),max_scatt_mech(3)
     &/time_1/dt,dtau,tot_time
     &/variables/p(20000,7),ip(20000),energy(20000)
     &/particle_atr/kx,ky,kz,iv,e
     &/frequency/freq(10,3)
        
      integer n_lev,nsim
      integer iv
      real kx,ky,kz,e

C     Reset counter for scattering frequency
      do i = 1,10
      do j = 1,3
c        freq(i,j) = 0.
      enddo
      enddo

      do i = 1, nsim	! loop for all carriers

C     Inverse mapping of particle atributes

      kx = p(i,1)
      ky = p(i,2)
      kz = p(i,3)
      dtau = p(i,4)
      iv = ip(i)
      e = energy(i)

C     Initial free-flight of the carriers

      dte = dtau
      if(dte.ge.dt)then
         dt2=dt
      else
         dt2=dte
      endif      
      call drift(dt2)       
      if(dte.gt.dt)goto 401

C     Free-flight and scatter part

402   dte2=dte
      call scatter_carrier(n_lev)          	
219   rr=ran(iso)
      if(rr.le.1e-6) go to 219
      dt3=-(log(rr))*tau_max(iv)
      dtp = dt - dte2	! remaining time to scatter in dt-interval
      if(dt3.le.dtp)then
	 dt2 = dt3
      else
	 dt2 = dtp
      endif 
      call drift(dt2)
	   
c     Update times

      dte2 = dte2 + dt3
      dte = dte2
      if(dte.lt.dt)goto 402
           
401   dte = dte - dt
      dtau = dte

C     Map particle atributes

      p(i,1) = kx
      p(i,2) = ky
      p(i,3) = kz
      p(i,4) = dtau
      ip(i) = iv
      energy(i) = e	             

      enddo

      return	
      end
