CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C       INITIALIZE CARRIER ENERGY AND WAVEVECTOR ACCORDING TO THE
C       MAXWELL-BOLTZMANN STATISTICS
C
C       Assumption:  All carriers are initially in valley 1 for GaAs
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC       
       subroutine init(nsim)
        
       common
     &/ran_var/iso
     &/pi/pi,two_pi  
     &/temp/tem,Vt
     &/ek/am(3),smh(3),hhm(3)
     &/nonp/af(3),af2(3),af4(3)
     &/scatt_par/emax,de,w(10,3),tau_max(3),max_scatt_mech(3)
     &/variables/p(20000,7),ip(20000),energy(20000)
     
       real k,kx,ky,kz,e, sume
       integer iv, nsim
       
       sume = 0.

       do i = 1, nsim
        
       e = -(1.5*Vt)*log(ran(iso))
       sume = sume + e

c      Initial valley index
	
       rr = 3.*ran(iso)	
       if(rr.le.1.)then
          iv=1
       elseif(rr.le.2.)then  
	  iv=2
       elseif(rr.le.3.)then
          iv=3
       endif
       iv=1 		! this is for GaAs materials

C      Initial wavevector

       k=smh(iv)*sqrt(e*(1.+af(iv)*e))
       fai=two_pi*ran(iso)
       ct=1.-2.*ran(iso)
       st=sqrt(1.-ct*ct)
       kx=k*st*cos(fai)
       ky=k*st*sin(fai)
       kz=k*ct

C      Initial free-flight

103    rr = ran(iso)
       if(rr.le.1.e-5)go to 103
       tc = -(log(rr))*tau_max(iv)

C      Map particle atributes
       
       p(i,1) = kx             
       p(i,2) = ky
       p(i,3) = kz
       p(i,4) = tc
       ip(i) = iv
       energy(i) = e

       enddo

       sume = sume/float(nsim)
       print*,'Average carrier energy - initial distribution'
       print*,'Energy = ',sume
       print*,'   '
	   
       return
       end
