CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C      READ INPUT PARAMETERS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       subroutine readin(n_lev)

       common
     &/ran_var/iso
     &/pi/pi,two_pi
     &/fund_const/q,h,kb,am0,eps_0 
     &/dri/qh
     &/temp/tem,Vt
     &/ek/am(3),smh(3),hhm(3)
     &/valley_splitting/split_L_gamma,split_X_gamma
     &/equiv_valleys/eq_valleys_gamma,eq_valleys_L,eq_valleys_X
     &/nonp/af(3),af2(3),af4(3)
     &/scatt_par/emax,de,w(10,3),tau_max(3),max_scatt_mech(3)
     &/dielec_func/eps_high,eps_low
     &/density/density,sound_velocity
     &/time_1/dt,dtau,tot_time
     &/force/fx,fy,fz
     &/select_acouctic/acoustic_gamma,acoustic_L,acoustic_X
     &/select_Coulomb/Coulomb_scattering
     &/select_polar/polar_gamma,polar_L,polar_X
     &/select_intervalley_1/intervalley_gamma_L
     &/select_intervalley_2/intervalley_gamma_X
     &/select_intervalley_3/intervalley_L_gamma
     &/select_intervalley_4/intervalley_L_L
     &/select_intervalley_5/intervalley_L_X
     &/select_intervalley_6/intervalley_X_gamma
     &/select_intervalley_7/intervalley_X_L
     &/select_intervalley_8/intervalley_X_X
     &/sigma_acoustic/sigma_gamma,sigma_L,sigma_X
     &/coulomb/doping_density,Energy_debye(3)    
     &/polar_en/polar_en_gamma,polar_en_L,polar_en_X
     &/Def_pot_1/DefPot_gamma_L,DefPot_gamma_X
     &/Def_pot_2/DefPot_L_gamma,DefPot_L_L,DefPot_L_X
     &/Def_pot_3/DefPot_X_gamma,DefPot_X_L,DefPot_X_X
     &/interval_phonons_1/phonon_gamma_L,phonon_gamma_X
     &/interval_phonons_2/phonon_L_gamma,phonon_L_L,phonon_L_X
     &/interval_phonons_3/phonon_X_gamma,phonon_X_L,phonon_X_X  
   
       real kb
       real fx,fy,fz
       real nonparabolicity_gamma
       real nonparabolicity_L
       real nonparabolicity_X

C      Define fundamental constants and general parameters

       iso=1345
       am0=9.11e-31
       h=1.05459e-34
       q=1.60219e-19
       qh=q/h  
       eps_0=8.85419e-12
       kb=1.38066e-23
       pi=4.*atan(1.0)
       two_pi = 2.*pi

C      Read parameters from input file

       open(unit=1,file='input_data',status='unknown')
       read(1,*)dt
       read(1,*)tot_time
       read(1,*)tem
       read(1,*)doping_density
       read(1,*)fx    
       read(1,*)fy
       read(1,*)fz
       read(1,*)rel_mass_gamma
       read(1,*)rel_mass_L
       read(1,*)rel_mass_X
       read(1,*)eps_high
       read(1,*)eps_low
       read(1,*)nonparabolicity_gamma
       read(1,*)nonparabolicity_L
       read(1,*)nonparabolicity_X
       read(1,*)split_L_gamma
       read(1,*)split_X_gamma
       read(1,*)eq_valleys_gamma
       read(1,*)eq_valleys_L
       read(1,*)eq_valleys_X
       read(1,*)density
       read(1,*)sound_velocity
       read(1,*)emax
       read(1,*)Coulomb_scattering
       read(1,*)acoustic_gamma
       read(1,*)acoustic_L
       read(1,*)acoustic_X
       read(1,*)polar_gamma
       read(1,*)polar_L
       read(1,*)polar_X
       read(1,*)intervalley_gamma_L
       read(1,*)intervalley_gamma_X
       read(1,*)intervalley_L_gamma
       read(1,*)intervalley_L_L
       read(1,*)intervalley_L_X
       read(1,*)intervalley_X_gamma
       read(1,*)intervalley_X_L
       read(1,*)intervalley_X_X
       close(1)

       Vt=kb*tem/q
       eps_high = eps_high*eps_0
       eps_low = eps_low*eps_0
       de=emax/float(n_lev)

C      Define coupling constants

       sigma_gamma = 7.01  !  [eV]
       sigma_L = 9.2  !  [eV]
       sigma_X = 9.0  !  [eV]

       polar_en_gamma = 0.03536  !  [eV]
       polar_en_L = 0.03536  !  [eV]
       polar_en_X = 0.03536  !  [eV]

       DefPot_gamma_L = 1.8E10   ! [eV/m]
       DefPot_gamma_X = 10.E10   ! [eV/m]
       DefPot_L_gamma = 1.8E10   ! [eV/m]
       DefPot_L_L = 5.E10   ! [eV/m]
       DefPot_L_X = 1.E10   ! [eV/m]
       DefPot_X_gamma = 10.E10   ! [eV/m]
       DefPot_X_L = 1.E10   ! [eV/m]
       DefPot_X_X = 10.E10   ! [eV/m]
   
       phonon_gamma_L = 0.0278  !  [eV]
       phonon_gamma_X = 0.0299  !  [eV]
       phonon_L_gamma = 0.0278  !  [eV]
       phonon_L_L = 0.029  !  [eV]
       phonon_L_X = 0.0293  !  [eV]
       phonon_X_gamma = 0.0299  !  [eV]
       phonon_X_L = 0.0293  !  [eV]
       phonon_X_X = 0.0299  !  [eV] 

C      Map parameters into internal variables used in the code

       am(1) = rel_mass_gamma*am0
       am(2) = rel_mass_L*am0
       am(3) = rel_mass_X*am0
       af(1) = nonparabolicity_gamma
       af(2) = nonparabolicity_L
       af(3) = nonparabolicity_X

       do i = 1,3	                
          smh(i)=sqrt(2.*am(i))*sqrt(q)/h
          hhm(i)=h/am(i)/q*h/2.
          af2(i) = 2.*af(i)
          af4(i) = 4.*af(i)
c         print*,af(i),af2(i),af4(i)
       enddo

       return
       end  

        
