CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    Subroutine for the calculation of acoustic phonons
C    scattering rate
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine acoustic_rate(i_count,i_region,n_lev,out_file)

       common
     &/pi/pi,two_pi 
     &/temp/tem,Vt
     &/fund_const/q,h,kb,am0,eps_0 
     &/dri/qh
     &/mass/amd,amc,smh,hhm,tm(3),hm(3)
     &/nonp/af,af2,af4
     &/scatt_par/emax,de,w(10,5),tau_max(5),max_scatt_mech(5)
     &/scatt_par2/flag_mech(10,5)
     &/table/scatt_table(4000,10,5)
     &/density/density,sound_velocity
     &/acoustic/sigma
     
      integer i_count,i_region,n_lev
      real kb
      character*30 out_file

C    Calculate constant

      c_l = density*sound_velocity*sound_velocity
      const = sqrt(2.)*kb*tem/pi/h/c_l
     1      * (amd/h)*(sqrt(amd)/h*sqrt(q))*(qh*q)
     2      * sigma*sigma

C    Create scattering table
                 
      i_count = i_count + 1
      open(unit = 10, file=out_file, status='unknown')
      write(10,*)'energy  ',out_file
      do i = 1, n_lev
         ee = de*float(i)
         fe = ee*(1.+af*ee)
         acoustic = const*sqrt(fe)*(1.+af2*ee)
         scatt_table(i,i_count,i_region) = acoustic
         write(10,*)ee,acoustic
      enddo
      close(10)
      
      flag_mech(i_count,i_region) = 1
      w(i_count,i_region) = 0.
      
      return
      end
