CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Subroutine for the calculation of COULOMB SCATTERING rate 
C     Assumption ==> elastic scattering process
c     (Brooks-Herring approach)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       subroutine Coulomb_BH(i_count,i_region,n_lev,out_file_1)
     
       common
     &/pi/pi,two_pi 
     &/temp/tem,Vt
     &/fund_const/q,h,kb,am0,eps_0 
     &/dri/qh
     &/mass/amd,amc,smh,hhm,tm(3),hm(3)
     &/nonp/af,af2,af4
     &/scatt_par/emax,de,w(10,5),tau_max(5),max_scatt_mech(5)
     &/scatt_par2/flag_mech(10,5)
     &/table/scatt_table(4000,10,5)
     &/dielec_func/eps_high
     &/coulomb/doping_density(5),Energy_debye(5)
      
      integer i_count,i_region,n_lev
      real kb
      character*30 out_file_1
     
C    Calculate constants:

      Debye_length = sqrt(eps_high*Vt/q/doping_density(i_region))
      Energy_debye(i_region) = hhm/Debye_length/Debye_length
      final_mass = amd
      factor = Debye_length*Debye_length/eps_high
      const = doping_density(i_region)*final_mass*qh
     1      * sqrt(2.*final_mass)/pi*qh
     2      * factor*qh*factor*qh*sqrt(q)   

C    Calculate scattering rate:

      i_count = i_count + 1
      open(unit=10, file=out_file_1, status='unknown')
      write(10,*)'energy  ',out_file_1
      
      do i = 1, n_lev
         ee = de*float(i)
         ge = ee*(1.+af*ee)
         factor = sqrt(ge)*(1.+af2*ee)
     1          / (1.+4.*ge/Energy_debye(i_region))
         scatt_rate = const*factor         
         scatt_table(i,i_count,i_region) = scatt_rate
         write(10,*)ee,scatt_rate
      enddo
      close(10)
              
      flag_mech(i_count,i_region) = 3
      w(i_count,i_region) = 0.

      return
      end
