CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C       INITIALIZE CARRIER ENERGY AND WAVEVECTOR ACCORDING TO THE
C       MAXWELL-BOLTZMANN STATISTICS
C
C       Assumption:  All carriers are initially in valley 1 for GaAs
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC       
       subroutine init(nsim,i_region)
        
       common
     &/ran_var/iso
     &/pi/pi,two_pi  
     &/temp/tem,Vt
     &/mass/amd,amc,smh,hhm,tm(3),hm(3)
     &/nonp/af,af2,af4
     &/scatt_par/emax,de,w(10,5),tau_max(5),max_scatt_mech(5)
     &/variables/p(20000,8),ip(20000),energy(20000)
     
       real k,kx,ky,kz,e,sume
       integer iv,nsim,i_region
       
       sume = 0.

       do i = 1, nsim
        
       e = -(1.5*Vt)*log(ran(iso))
       sume = sume + e

c      Initial valley index and region
	
       rr = 3.*ran(iso)	
       if(rr.le.1.)then
          iv=1
       elseif(rr.le.2.)then  
	  iv=2
       elseif(rr.le.3.)then
          iv=3
       endif

C      Initial wavevector

       k=smh*sqrt(e*(1.+af*e))
       fai=two_pi*ran(iso)
       ct=1.-2.*ran(iso)
       st=sqrt(1.-ct*ct)
       kx=k*st*cos(fai)
       ky=k*st*sin(fai)
       kz=k*ct

C      Initial free-flight

103    rr = ran(iso)
       if(rr.le.1.e-5)go to 103
       tc = -(log(rr))*tau_max(i_region)

C      Map particle atributes
       
       p(i,1) = kx             
       p(i,2) = ky
       p(i,3) = kz
       p(i,4) = tc
       p(i,8) = i_region
       ip(i) = iv
       energy(i) = e

       enddo

       sume = sume/float(nsim)
       print*,'Average carrier energy - initial distribution'
       print*,'Energy = ',sume
       print*,'   '
	   
       return
       end
