CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Generic subroutine for the calculation of 
C     INTERVALLEY PHONONS scattering rate
c     (absorption + emission)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       subroutine intervalley_first_order(i_count,i_region,n_lev,w0,
     1                        out_file_1,out_file_2)
     
       common
     &/pi/pi,two_pi 
     &/temp/tem,Vt
     &/fund_const/q,h,kb,am0,eps_0 
     &/dri/qh
     &/mass/amd,amc,smh,hhm,tm(3),hm(3)
     &/nonp/af,af2,af4
     &/scatt_par/emax,de,w(10,5),tau_max(5),max_scatt_mech(5)
     &/scatt_par2/flag_mech(10,5)
     &/table/scatt_table(4000,10,5)
     &/density/density,sound_velocity
     &/intervalley1/coupling_constant
     &/intervalley2/delta_fi,final_valleys,i_mech

      integer i_count,i_region,n_lev
      real kb, w0
      character*30 out_file_1, out_file_2
     
C    Calculate constants
      print*,'here'
      rnq = 1./(exp(w0/Vt)-1.)
      final_mass = amd
      const = final_valleys*sqrt(2.)*(coupling_constant**2.)
     1      * qh*final_mass*qh*sqrt(q)/h/(pi*density*w0)
     2      * (final_mass/h)*sqrt(final_mass)
      print*,'constant = ',const

C    (a) Scattering rate - absorption

      i_count = i_count + 1
      open(unit=10, file=out_file_1, status='unknown')
      write(10,*)'energy  ',out_file_1
      ab = rnq*const
      
      do i = 1, n_lev
         ee = de*float(i)
         ef = ee + w0 - delta_fi
         ge = ee*(1.+af*ee)
         gf = ef*(1.+af*ef)
         if(ef.le.0)then
            absorption = 0.
         else
            factor = sqrt(gf)*(ge+gf)*(1.+af2*ef)
            absorption = ab*factor
         endif
         scatt_table(i,i_count,i_region) = absorption
         write(10,*)ee,absorption
      enddo
      close(10)
              
      flag_mech(i_count,i_region) = i_mech
      w(i_count,i_region) = w0 - delta_fi

C    (b) Scattering rate - emission

      i_count = i_count + 1
      open(unit=11, file=out_file_2, status='unknown')
      write(11,*)'energy  ',out_file_2
      em = (1.+rnq)*const
      
      do i = 1, n_lev
         ee = de*float(i)
         ef = ee - w0 - delta_fi
         ge = ee*(1.+af*ee)
         gf = ef*(1.+af*ef)
         if(ef.le.0)then
            emission = 0.
         else
            factor = sqrt(gf)*(ge+gf)*(1.+af2*ef)
            emission = em*factor
         endif
         scatt_table(i,i_count,i_region) = emission
         write(11,*)ee,emission
      enddo
      close(11)
            
      flag_mech(i_count,i_region) = i_mech
      w(i_count,i_region) = - w0 - delta_fi

      return
      end
